#import "Escaper.h"
#import	<string>


static const char	NON_TARGET[] =
{
//	';', '/', '?', ':', '@', '&', '=', '+', '$',
	'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
	'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
	'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '_',
//	'-', '.', '!', '~', '*', '\'', '(', ')'
};






static NSString*
encode(
	NSData*	inData)
{
	const unsigned char*	p;
	const unsigned char*	end;
	NSString*	encoded = [NSString string];
	if (inData == nil) {
		return (encoded);
	}
	p = (const unsigned char*)[inData bytes];
	end = p + [inData length] - 1;
	for (; p <= end; ++p) {
		unsigned char	c = *p;
		size_t	idx;
		BOOL	isFound = NO;
		for (idx = 0; idx < sizeof(NON_TARGET)/sizeof(NON_TARGET[0]); ++idx) {
			if (c == NON_TARGET[idx]) {
				isFound = YES;
				break;
			}
		}
		if (!isFound) {
			encoded = [encoded stringByAppendingFormat:@"%%%02x", c & 0xFF];
		}
		else {
			encoded = [encoded stringByAppendingFormat:@"%c", c & 0xFF];
		}
	}
	return (encoded);
}



static unsigned char
dehex(
	unsigned char	c)
{
	if ('a' <= c && c <= 'f') {
		c = c - 'a' + 10;
	}
	else if ('A' <= c && c <= 'F') {
		c = c - 'A' + 10;
	}
	else if ('0' <= c && c <= '9') {
		c -= '0';
	}
	return (c);
}



static NSString*
decode(
	NSData*				inData,
	NSStringEncoding	inEncode)
{
	const unsigned char*	p;
	const unsigned char*	end;
	std::string string;
	if (inData == nil) {
		return (@"");
	}
	p = (const unsigned char*)[inData bytes];
	end = p + [inData length] - 1;
	for (; p <= end; ++p) {
		unsigned char	c = *p;
		if (c != '%') {
			string.push_back(c);
		}
		else {
			if (p + 2 <= end) {
				unsigned char	c1 = *(p + 1);
				unsigned char	c2 = *(p + 2);
				c1 = dehex(c1);
				c2 = dehex(c2);
				
				c = (c1 << 4) + c2;
				p += 2;
			}
			string.push_back(c);
		}
	}
	const char* bytes = string.c_str();
	return ([[[NSString alloc] initWithBytes:bytes length:string.size() encoding:inEncode] autorelease]);
}



static NSStringEncoding
ConvertToNSStringEncoding(
	int	inEncoding)
{
	NSStringEncoding	e = NSJapaneseEUCStringEncoding;
	switch (inEncoding) {
		case 0: {
			e = NSJapaneseEUCStringEncoding;
//			NSLog(@"NSJapaneseEUCStringEncoding");
			break;
		}
		case 1: {
			e = NSShiftJISStringEncoding;
//			NSLog(@"NSShiftJISStringEncoding");
			break;
		}
		case 2: {
			e = NSISO2022JPStringEncoding;
//			NSLog(@"NSISO2022JPStringEncoding");
			break;
		}
		case 3: {
			e = NSUTF8StringEncoding;
//			NSLog(@"NSUTF8StringEncoding");
			break;
		}
	}
	return (e);
}




@implementation Escaper



- (id)
init
{
	self = [super init];
	if (self != nil) {
	}
	return (self);
}



- (void)
dealloc
{
}



- (IBAction)
escape:	(id)	inSender
{
	int	tag = [[inSender selectedCell] tag];
	
	NSStringEncoding	e = ConvertToNSStringEncoding(tag);
	NSData*	data = [[textField stringValue] dataUsingEncoding:e allowLossyConversion:YES];
	NSString*	encoded = encode(data);
	[URIField setStringValue:encoded];
}



- (IBAction)
unescape:	(id)	inSender
{
	int	tag = [[inSender selectedCell] tag];
	
	NSData*	data = [[URIField stringValue] dataUsingEncoding:NSJapaneseEUCStringEncoding allowLossyConversion:YES];
	NSStringEncoding	e = ConvertToNSStringEncoding(tag);
	NSString*	decoded = decode(data, e);
	if (decoded != nil) {
		[textField setStringValue:decoded];
	}
	else {
		[textField setStringValue:@""];
	}
}



@end
